; (function () {
  var u = navigator.userAgent;
  var isAndroid = u.indexOf('Android') > -1 || u.indexOf('Adr') > -1; //android终端
  var isiOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/); //ios终端
// window.DAWebViewJavascriptBridge 校验，避免重复
if (window.DAWebViewJavascriptBridge) {
  return;
}

// window.WebViewJavascriptBridge 声明
  window.DAWebViewJavascriptBridge = {
  callHandler: callHandler,
  _handleMessageFromObjC: _handleMessageFromObjC
  };

  var responseCallbacks = {}; // JS 端存放回调的字典
  var uniqueId = 1; // 唯一标示，用于回调时生成 callbackId


  function callHandler(className, methodName, data, responseCallback) {
    // 没数据参数时的处理
    if (arguments.length == 4 && typeof data == 'function') {
      responseCallback = data;
      data = null;
    }
    _doSend({ className: className, methodName: methodName, data: data }, responseCallback);
  }


//alert("注入成功")

  // 如有回调，则设置 message['callbackId'] 与 responseCallbacks[callbackId]
  function _doSend(message, responseCallback) {
    if (responseCallback) {
      var callbackId = 'zm_' + (uniqueId++) + '_' + new Date().getTime();
      responseCallbacks[callbackId] = responseCallback;
      message['callbackId'] = callbackId;
    }

//alert("调用成功 " + message.methodName)
    window.android.agentRequest(JSON.stringify(message));
//    window.webkit.messageHandlers.ZMIMSDK.postMessage(message);
  }


  //  收到iOS端消息
  function _handleMessageFromObjC(messageJSON) {
    var json =messageJSON.replace(/\s+/g,"  ")
    _dispatchMessageFromObjC(messageJSON);
  }

  // 核心代码，调度从 Native 端获取到的消息
  function _dispatchMessageFromObjC(messageJSON) {
    _doDispatchMessageFromObjC(messageJSON);
    // 解析 msgJSON 得到 msg
    function _doDispatchMessageFromObjC(messageJSON) {
      var message = JSON.parse(messageJSON);
      var messageHandler;
      var responseCallback;

      // 如果有callbackId，则说明是回调，取对应的 responseCallback 执行，之后释放
      if (message.callbackId) {
        responseCallback = responseCallbacks[message.callbackId];
        if (!responseCallback) {
          return;
        }
        responseCallback(message.status,message.data);
        delete responseCallbacks[message.callbackId];
      } else {
        // 没有 responseId，则表示正常的 iOS call handler 调用 js

      }
    }
  }
}
)();
